]> git.ipfire.org Git - thirdparty/git.git/blame - git-fetch.sh
Shell utilities: Guard against expr' magic tokens.
[thirdparty/git.git] / git-fetch.sh
CommitLineData
7ef76925
LT
1#!/bin/sh
2#
87358b7a
FK
3
4USAGE='<fetch-options> <repository> <refspec>...'
ae2b0f15 5. git-sh-setup
215a7ad1 6. git-parse-remote
853a3697
JH
7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
9
221e743c
JH
10LF='
11'
12IFS="$LF"
13
03febf99 14no_tags=
ed1aadf1 15tags=
853a3697 16append=
ae2da406 17force=
583122cd 18verbose=
b10ac50f 19update_head_ok=
2c620a1a 20exec=
96b086d6 21upload_pack=
ae2da406
JH
22while case "$#" in 0) break ;; esac
23do
24 case "$1" in
25 -a|--a|--ap|--app|--appe|--appen|--append)
26 append=t
ae2da406 27 ;;
2796a9de
JH
28 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
29 --upload-pa|--upload-pac|--upload-pack)
2c620a1a
MO
30 shift
31 exec="--exec=$1"
96b086d6 32 upload_pack="-u $1"
2c620a1a 33 ;;
ae2da406
JH
34 -f|--f|--fo|--for|--forc|--force)
35 force=t
b10ac50f 36 ;;
ed1aadf1
LT
37 -t|--t|--ta|--tag|--tags)
38 tags=t
39 ;;
03febf99
JH
40 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
41 no_tags=t
42 ;;
b10ac50f
JH
43 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
44 --update-he|--update-hea|--update-head|--update-head-|\
45 --update-head-o|--update-head-ok)
46 update_head_ok=t
ae2da406 47 ;;
583122cd
LT
48 -v|--verbose)
49 verbose=Yes
50 ;;
0f76f526
TP
51 -k|--k|--ke|--kee|--keep)
52 keep=--keep
53 ;;
87358b7a
FK
54 -*)
55 usage
56 ;;
ae2da406
JH
57 *)
58 break
59 ;;
60 esac
b10ac50f 61 shift
ae2da406
JH
62done
63
853a3697
JH
64case "$#" in
650)
92c533ef
JH
66 test -f "$GIT_DIR/branches/origin" ||
67 test -f "$GIT_DIR/remotes/origin" ||
b10ac50f 68 die "Where do you want to fetch from today?"
92c533ef 69 set origin ;;
853a3697 70esac
ae2da406 71
853a3697
JH
72remote_nick="$1"
73remote=$(get_remote_url "$@")
74refs=
75rref=
76rsync_slurped_objects=
77
78if test "" = "$append"
79then
df34297a 80 : >"$GIT_DIR/FETCH_HEAD"
853a3697
JH
81fi
82
83append_fetch_head () {
84 head_="$1"
85 remote_="$2"
86 remote_name_="$3"
87 remote_nick_="$4"
88 local_name_="$5"
05dd8e2e
JH
89 case "$6" in
90 t) not_for_merge_='not-for-merge' ;;
91 '') not_for_merge_= ;;
92 esac
853a3697 93
06ec2b4b
JH
94 # remote-nick is the URL given on the command line (or a shorthand)
95 # remote-name is the $GIT_DIR relative refs/ path we computed
96 # for this refspec.
687b8be8
EW
97
98 # the $note_ variable will be fed to git-fmt-merge-msg for further
99 # processing.
06ec2b4b
JH
100 case "$remote_name_" in
101 HEAD)
102 note_= ;;
103 refs/heads/*)
104 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
b91fb518 105 note_="branch '$note_' of " ;;
06ec2b4b
JH
106 refs/tags/*)
107 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
b91fb518 108 note_="tag '$note_' of " ;;
687b8be8
EW
109 refs/remotes/*)
110 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
111 note_="remote branch '$note_' of " ;;
06ec2b4b 112 *)
b91fb518 113 note_="$remote_name of " ;;
06ec2b4b 114 esac
f327dbce 115 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
b91fb518
JH
116 remote_="$remote_1_"
117 note_="$note_$remote_"
06ec2b4b 118
853a3697
JH
119 # 2.6.11-tree tag would not be happy to be fed to resolve.
120 if git-cat-file commit "$head_" >/dev/null 2>&1
121 then
8572aa85 122 headc_=$(git-rev-parse --verify "$head_^0") || exit
df34297a 123 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
124 [ "$verbose" ] && echo >&2 "* committish: $head_"
125 [ "$verbose" ] && echo >&2 " $note_"
853a3697 126 else
df34297a 127 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
128 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
129 [ "$verbose" ] && echo >&2 " $note_"
853a3697
JH
130 fi
131 if test "$local_name_" != ""
132 then
133 # We are storing the head locally. Make sure that it is
134 # a fast forward (aka "reverse push").
06ec2b4b 135 fast_forward_local "$local_name_" "$head_" "$note_"
853a3697
JH
136 fi
137}
138
139fast_forward_local () {
866ff2f7 140 mkdir -p "$(dirname "$GIT_DIR/$1")"
853a3697
JH
141 case "$1" in
142 refs/tags/*)
143 # Tags need not be pointing at commits so there
144 # is no way to guarantee "fast-forward" anyway.
ae2da406
JH
145 if test -f "$GIT_DIR/$1"
146 then
f8765797
JH
147 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
148 then
583122cd 149 [ "$verbose" ] && echo >&2 "* $1: same as $3"
f8765797
JH
150 else
151 echo >&2 "* $1: updating with $3"
152 fi
ae2da406 153 else
06ec2b4b 154 echo >&2 "* $1: storing $3"
ae2da406 155 fi
687b8be8 156 git-update-ref "$1" "$2"
bf7960eb 157 ;;
ae2da406 158
687b8be8 159 refs/heads/* | refs/remotes/*)
bf7960eb
JH
160 # $1 is the ref being updated.
161 # $2 is the new value for the ref.
162 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
163 if test "$local"
33b83034 164 then
bf7960eb 165 # Require fast-forward.
853a3697
JH
166 mb=$(git-merge-base "$local" "$2") &&
167 case "$2,$mb" in
168 $local,*)
06ec2b4b 169 echo >&2 "* $1: same as $3"
853a3697
JH
170 ;;
171 *,$local)
06ec2b4b 172 echo >&2 "* $1: fast forward to $3"
9d7f73d4 173 echo >&2 " from $local to $2"
bf7960eb 174 git-update-ref "$1" "$2" "$local"
853a3697
JH
175 ;;
176 *)
177 false
178 ;;
179 esac || {
06ec2b4b 180 echo >&2 "* $1: does not fast forward to $3;"
bf7960eb
JH
181 case ",$force,$single_force," in
182 *,t,*)
06ec2b4b 183 echo >&2 " forcing update."
bf7960eb 184 git-update-ref "$1" "$2" "$local"
ae2da406
JH
185 ;;
186 *)
bf7960eb 187 echo >&2 " not updating."
a9698bb2 188 exit 1
ae2da406
JH
189 ;;
190 esac
853a3697
JH
191 }
192 else
bf7960eb
JH
193 echo >&2 "* $1: storing $3"
194 git-update-ref "$1" "$2"
33b83034 195 fi
0a623e7c 196 ;;
853a3697
JH
197 esac
198}
199
b10ac50f
JH
200case "$update_head_ok" in
201'')
bf7960eb 202 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
203 ;;
204esac
205
ed1aadf1
LT
206# If --tags (and later --heads or --all) is specified, then we are
207# not talking about defaults stored in Pull: line of remotes or
208# branches file, and just fetch those and refspecs explicitly given.
209# Otherwise we do what we always did.
210
211reflist=$(get_remote_refs_for_fetch "$@")
212if test "$tags"
213then
81214e4d 214 taglist=$(IFS=" " &&
96b086d6 215 git-ls-remote $upload_pack --tags "$remote" |
81214e4d
JH
216 while read sha1 name
217 do
218 case "$name" in
219 (*^*) continue ;;
220 esac
221 if git-check-ref-format "$name"
222 then
223 echo ".${name}:${name}"
224 else
225 echo >&2 "warning: tag ${name} ignored"
226 fi
227 done)
ed1aadf1
LT
228 if test "$#" -gt 1
229 then
230 # remote URL plus explicit refspecs; we need to merge them.
221e743c 231 reflist="$reflist$LF$taglist"
ed1aadf1
LT
232 else
233 # No explicit refspecs; fetch tags only.
234 reflist=$taglist
235 fi
236fi
237
03febf99
JH
238fetch_main () {
239 reflist="$1"
240 refs=
f170e4b3 241
03febf99
JH
242 for ref in $reflist
243 do
244 refs="$refs$LF$ref"
f170e4b3 245
03febf99
JH
246 # These are relative path from $GIT_DIR, typically starting at refs/
247 # but may be HEAD
f327dbce 248 if expr "z$ref" : 'z\.' >/dev/null
03febf99
JH
249 then
250 not_for_merge=t
f327dbce 251 ref=$(expr "z$ref" : 'z\.\(.*\)')
03febf99
JH
252 else
253 not_for_merge=
254 fi
f327dbce 255 if expr "z$ref" : 'z\+' >/dev/null
03febf99
JH
256 then
257 single_force=t
f327dbce 258 ref=$(expr "z$ref" : 'z\+\(.*\)')
03febf99
JH
259 else
260 single_force=
261 fi
f327dbce
MW
262 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
263 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
853a3697 264
03febf99 265 rref="$rref$LF$remote_name"
4447badc 266
03febf99
JH
267 # There are transports that can fetch only one head at a time...
268 case "$remote" in
269 http://* | https://*)
270 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
271 curl_extra_args="-k"
272 fi
273 remote_name_quoted=$(perl -e '
274 my $u = $ARGV[0];
275 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
276 print "$u";
277 ' "$remote_name")
278 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
f327dbce 279 expr "z$head" : "z$_x40\$" >/dev/null ||
03febf99
JH
280 die "Failed to fetch $remote_name from $remote"
281 echo >&2 Fetching "$remote_name from $remote" using http
282 git-http-fetch -v -a "$head" "$remote/" || exit
283 ;;
284 rsync://*)
285 TMP_HEAD="$GIT_DIR/TMP_HEAD"
286 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
287 head=$(git-rev-parse --verify TMP_HEAD)
288 rm -f "$TMP_HEAD"
289 test "$rsync_slurped_objects" || {
290 rsync -av --ignore-existing --exclude info \
291 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
853a3697 292
03febf99
JH
293 # Look at objects/info/alternates for rsync -- http will
294 # support it natively and git native ones will do it on
295 # the remote end. Not having that file is not a crime.
296 rsync -q "$remote/objects/info/alternates" \
297 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
298 rm -f "$GIT_DIR/TMP_ALT"
299 if test -f "$GIT_DIR/TMP_ALT"
300 then
301 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
302 while read alt
303 do
304 case "$alt" in 'bad alternate: '*) die "$alt";; esac
305 echo >&2 "Getting alternate: $alt"
306 rsync -av --ignore-existing --exclude info \
307 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
308 done
309 rm -f "$GIT_DIR/TMP_ALT"
310 fi
311 rsync_slurped_objects=t
312 }
313 ;;
314 *)
315 # We will do git native transport with just one call later.
316 continue ;;
317 esac
f170e4b3 318
03febf99
JH
319 append_fetch_head "$head" "$remote" \
320 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
853a3697 321
03febf99
JH
322 done
323
324 case "$remote" in
325 http://* | https://* | rsync://* )
326 ;; # we are already done.
327 *)
328 ( : subshell because we muck with IFS
329 IFS=" $LF"
330 (
b19696c2 331 git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
03febf99
JH
332 ) |
333 while read sha1 remote_name
334 do
335 case "$sha1" in
336 failed)
337 echo >&2 "Fetch failure: $remote"
338 exit 1 ;;
339 esac
340 found=
341 single_force=
342 for ref in $refs
343 do
344 case "$ref" in
345 +$remote_name:*)
346 single_force=t
347 not_for_merge=
348 found="$ref"
349 break ;;
350 .+$remote_name:*)
351 single_force=t
352 not_for_merge=t
353 found="$ref"
354 break ;;
355 .$remote_name:*)
356 not_for_merge=t
357 found="$ref"
358 break ;;
359 $remote_name:*)
360 not_for_merge=
361 found="$ref"
362 break ;;
363 esac
364 done
f327dbce 365 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
03febf99
JH
366 append_fetch_head "$sha1" "$remote" \
367 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
368 done
369 ) || exit ;;
370 esac
371
372}
373
374fetch_main "$reflist"
375
376# automated tag following
377case "$no_tags$tags" in
378'')
6dc78e69
JH
379 case "$reflist" in
380 *:refs/*)
381 # effective only when we are following remote branch
382 # using local tracking branch.
383 taglist=$(IFS=" " &&
384 git-ls-remote $upload_pack --tags "$remote" |
385 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
386 while read sha1 name
387 do
388 test -f "$GIT_DIR/$name" && continue
389 git-check-ref-format "$name" || {
390 echo >&2 "warning: tag ${name} ignored"
391 continue
392 }
393 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
394 echo >&2 "Auto-following $name"
395 echo ".${name}:${name}"
396 done)
397 esac
03febf99
JH
398 case "$taglist" in
399 '') ;;
400 ?*)
401 fetch_main "$taglist" ;;
402 esac
853a3697 403esac
b10ac50f
JH
404
405# If the original head was empty (i.e. no "master" yet), or
406# if we were told not to worry, we do not have to check.
407case ",$update_head_ok,$orig_head," in
408*,, | t,* )
409 ;;
410*)
bf7960eb 411 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
412 if test "$curr_head" != "$orig_head"
413 then
bf7960eb 414 git-update-ref HEAD "$orig_head"
b10ac50f
JH
415 die "Cannot fetch into the current branch."
416 fi
417 ;;
418esac